unit FormatFloat_Misc2;

interface

//C:\maXbook\kleiner2005\Delphi_InterBase\seekmachine

//uses
  //Windows, SysUtils, Classes, ibase;

      function CloseDebuggerOutput: Integer; //cdecl; export;
      function ADebug(szDebuggerOutput: PChar): Integer; //cdecl; export;
      (* Return what IB THINKS is the temp path *)
      function IBTempPath: PChar; //cdecl; export;
      function SetDebuggerOutput(szOutputFile: PChar): Integer; //cdecl; export;
      function ValidateCycleExpression(szCycleExpression: PChar;
        var ExprStart: Integer): Integer; //cdecl; export;
      function EvaluateCycleExpression(szCycleExpression: PChar;
        var ExprStart: Integer; OldDate, NewDate: TDatetime;//PISC_QUAD;
        var Amount: Double): Integer; //cdecl; export;
      function EvaluateExpression(szExpr: PChar;
        szSymbols: PChar): PChar; //cdecl; export;
        
        function input: integer; //forward;
        procedure unput(c: integer); //forward;

//const
  //WhiteSpace = [' ', #9, #10, #13];

var
  hDebugger: THandle;
  csDebugger: TRTLCriticalSection;

implementation

//uses
  //udf_glob, StrFncs, TimeFncs, StdFuncs, VariantSymbolTable,
  //(//Symbols, ExprParser;
  
const
  yylmax = 1023;
  yylmax1 = yylmax + 1;
  
var yyin, yyout, yyerr: TStream;
  sym_name: String;
  sym_val: Variant;
  
  type
	yy_state_t = byte;
const
	YYNEWLINE = 10;
	INITIAL = 0;
	YYSYMBOL_VALUE = 2;
const
	yy_endst = 15;
	yy_nxtmax = 314;

var  
  yylineno,
  yyleng,
  yy_end,
  yy_start,
  yy_lastc: Integer;
  yy_save: char;		(* saved yytext[yyleng] *)
  
{$IFNDEF YYTEXT_BUF_EXTERNAL}
	yytext: array[0..YYLMAX1] of char; (* text buffer (really yytext) *)
{$ENDIF}
	yy_sbuf: array[0..YYLMAX1] of yy_state_t;	(* state buffer *)
{$IFNDEF YYIOSTREAMED}
{$IFNDEF YYFILE_EXTERNAL}
	ayyin,
	ayyout,
        ayyerr: text;
{$ENDIF}
{$ENDIF}
	yyLexFatal: integer;

  
procedure YY_SCANNER; forward;
procedure YY_USER; forward;

procedure YY_USER;	(* set up yytext for user *)
begin
  yy_save := yytext[yyleng];
  yytext[yyleng] := '0'; //Char(0)
end;

procedure YY_SCANNER;	(* set up yytext for scanner *)
begin
  yytext[yyleng] := yy_save
end;

procedure yyless (n: integer);
begin
  if (n >= 0) and (n <= yy_end) then begin
    YY_SCANNER;
    yyleng := n;
    YY_USER
  end
end;

(* The following (yycomment) can be changed *)

(*
 * yygetc: return next character from input
 * Turbo Pascal seems to have a bug in release 4.0
 * wherein Eof(yyin) fails after ^Z is typed on a terminal read
 * Suppress runtime library checking and do our own.
 *)
function yygetc : integer;
var
  ch: char;
begin
//{$IFNDEF YYIOSTREAMED}
 (* if not EOF(yyin) then begin
    Read(yyin, ch);
    if IOResult <> 0 then
      result := -1
    else
      result := ord(ch)
  end else
    result := -1
{$ELSE}   *)
  (* Read the input from TStream object *)
 (* if yyin.Position < yyin.Size then begin
    yyin.ReadBuffer(ch, 1);
    result := Ord(ch);
  end else
    result := -1;
{$ENDIF} *)
end;

 
  
  (* get input char with pushback *)
function input: integer;
var
  c: integer;
begin
  if yy_end > yyleng then begin
    dec(yy_end);
    for c := 0 to yy_end-yyleng-1 do
      yytext[yyleng+c] := yytext[yyleng+1+c];
    c := ord(yy_save);
    YY_USER;
  end else
    c := yygetc;
  yy_lastc := c;
  if c = YYNEWLINE then
    inc(yylineno);
  result := c;
end;

(* pushback char *)
procedure unput(c: integer);
var
  i: word;
begin
  if yy_end >= YYLMAX then
    //YY_FATAL('Push-back buffer overflow')
  else begin
    if yy_end > yyleng then begin
      yytext[yyleng] := yy_save;
      for i := 0 to yy_end - yyleng - 1 do
        yytext[yyleng+i+1] := yytext[yyleng];
      yytext[yyleng] := Chr(0);
    end;
    inc(yy_end);
    yy_save := chr(c);

    if c = YYNEWLINE then
      dec(yylineno);
  end;
end;

procedure yyerror(msg: String);
begin
  msg := msg + CRLF;
  yyerr.WriteBuffer(msg[1], Length(msg));
end;

procedure YY_INIT;
begin
  yy_start := 0;
  yyleng := 0;
  yy_end := 0;
  yy_lastc := YYNEWLINE
end;

procedure yy_reset;
begin
  YY_INIT;
  yylineno := 1;
end;

procedure YYBEGIN (state: integer);
begin
  yy_start := state
end;

procedure NLSTATE;
begin
  yy_lastc := YYNEWLINE
end;


   
procedure GetValue(delim: Integer);
var
  ch, i: Integer;
begin
  ch := input;
  i := 0;
  while ((ch > 0) and (i < yylmax1)) do begin
    if (ch = delim) then begin
      ch := input;
      if (ch <> delim) then begin
        unput(ch);
	break;
      end;
    end;
    yytext[i] := Chr(ch);
    Inc(i);
    ch := input;
  end;
  if (ch <= 0) then
    yyerror('EOF detected in symbol value');
  if (i = yylmax1) then
    yyerror('String too long');
  yytext[i] := #0;
end;


{procedure yy_reset;
begin
  YY_INIT;
  yylineno := 1;
end; }

{procedure YYBEGIN (state: integer);
begin
  yy_start := state
end;

procedure NLSTATE;
begin
  yy_lastc := YYNEWLINE
end;
}

	type tableyy_begin = array[0..4] of yy_state_t;
	type tableyy_base = array[0..15] of integer;
	type tableyy_check = array[0..315] of yy_state_t;
	type tableyy_final = array[0..15] of integer;
	type tableyy_look = array[0..0] of byte;
	
  tblyy_default = array of integer; //1; //tableyy_base; //tableyy_default = 
	
const
  YY_INTERACTIVE = 1;  (* bit faster if 0 *)	
  YY_LA_SIZE = 2;
 // const tblyy_default = 1; //tableyy_base; //tableyy_default = 
	
	{$IFNDEF YYWRAP_EXTERNAL}
function yywrap: integer;
begin
  result:= 1;
end;
{$ENDIF}


function yylex : integer;

{LINE 230 c:/etc/yylex.pas}

var
	retval, c, i, yyst, yybase: integer;
	yyfmin, yyfmax: integer;	//(* yy_la_act index of final states *)
	yyoldi, yyoleng: integer;	//(* base i, yyleng before look-ahead *)
	yyeof: integer;			//7/(* 1 if eof has already been read *)
	var 	tblyy_begin: tableyy_begin;
	  tblyy_base: tableyy_base;
	  tblyy_check: tableyy_check;
	  tblyy_final: tableyy_final;
	  tblyy_look: tableyy_look;
	  yybits: array[0..7] of Byte;
	  tblyy_la_act: array[0..10] of word;

label
	yy_again,
	yy_contin,
	yy_jammed,
	yy_search,
	yy_found,
	done_loop,
	loop_exit,
	yy_reject,
	yy_more,
	yylexReturn;

begin
  yyLexFatal := 0;
  yyeof := 0;
  i := yyleng;
  YY_SCANNER;

  yy_again:
    yyleng := i;
    (* determine previous char. *)
    if i > 0 then
      yy_lastc:= strtoint(yytext[i-1]);
    (* scan previously accepted token adjusting yylineno *)
    while (i > 0) do begin
      dec(i);
   //{   if Inttostr(yytext[i]) = YYNEWLINE then
        inc(yylineno)
    end;
    
    (* adjust pushback *)
    dec1(yy_end, yyleng);
    for i := 0 to yy_end - 1 do
      yytext[i] := yytext[yyleng + i];
    i := 0;
   yy_contin:
     yyoldi := i;

    (* run the state machine until it jams *)
    if yy_lastc = YYNEWLINE then
      yyst := tblyy_begin[yy_start + 1]
    else
      yyst := tblyy_begin[yy_start];
    yy_sbuf[i] := yyst;

   repeat
     if i >= YYLMAX then begin
        writeln('//YY_FATAL(''Token buffer overflow'');');
	    if yyLexFatal = 1 then begin
	    retval := -2;
	      //goto yylexReturn;
       end;
     end;
      (* get input char *)
      if i < yy_end then
        c := strtoint(yytext[i])    (* get pushback char *)
      else begin
      	if yyeof = 0 then
	  c := yygetc
        else
	  c := -1;
        if c <> -1 then begin
          yy_end := i+1;
	  yytext[i] := chr(c)
        end else begin	(* end of file *)
          if i = yyoldi then begin
            yyeof := 0;
	    if yywrap <> 0 then begin
              retval := 0;
              //goto yylexReturn
            end else
              //goto yy_again
          end else begin
            yyeof := 1;	(* don't re-read EOF *)
            //goto loop_exit
          end
        end
      end;
      //end;
      (* look up next state *)
      yybase := tblyy_base[yyst] + c;
      while (yybase > yy_nxtmax) or (tblyy_check[yybase] <> yyst) do begin
        if yyst = yy_endst then
          goto yy_jammed;
        yyst := 1; //tblyy_default[yyst];
        yybase := tblyy_base[yyst] + c
      //end;
      //(/yyst := tblyy_next[yybase];

     yy_jammed:
      inc(i);
      yy_sbuf[i] := yyst
      end;
     //end; 
    //test until  yyst = yy_endst;
    
    until (yyst = yy_endst) or (YY_INTERACTIVE <> 0) and
          (tblyy_base[yyst] > yy_nxtmax); {and
          //(tblyy_default[yyst] = yy_endst)} //;

  loop_exit:
    if yyst <> yy_endst then
      inc(i);

  yy_search:
    (* search backward for a final state *)
    dec(i);
    while i > yyoldi do begin
      yyst := yy_sbuf[i];
      yyfmin := tblyy_final[yyst];
      yyfmax := tblyy_final[yyst+1];
      if yyfmin < yyfmax then
        goto yy_found;	(* found final state(s) *)
      dec(i);
    //end;
    (* no match, default action *)
    i := yyoldi + 1;
    //output(chr(yytext[yyoldi]));
    //goto yy_again;

  yy_found:
    yyoleng := i;		(* save length for REJECT *)
    (* pushback look-ahead RHS *)
    //c := (integer(tblyy_la_act[yyfmin]) shr 9) - 1;
    end;
    if c >= 0 then begin		(* trailing context? *)
      while true do begin
        dec(i);
        if i < yyoldi then begin
          i := yyoleng;
          //goto done_loop
        end else begin
          yyst := yy_sbuf[i];
          if ((tblyy_look[c*YY_LA_SIZE+word(yyst) div 8] and
               yybits[word(yyst) mod 8]) <> 0) then
            //goto done_loop;
        end
      end;
    done_loop:
    end;

    (* perform action *)
    yyleng := i;
    YY_USER;
    
   //7yylexReturn:
    //result := retval


  Case (tblyy_la_act[yyfmin] and $1FF) of
0:
begin
{LINE 45 Symbols.l}
	
  //sym_name := String(yytext);
  YYBEGIN(YYSYMBOL_VALUE);
end;
1:
begin
{LINE 49 Symbols.l}
	
  // Do nothing with whitespace

end;
2:
begin
{LINE 52 Symbols.l}
	
  //GetValue(Integer(''''));
  //sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  //goto yylexReturn;

end;
3:
begin
{LINE 59 Symbols.l}
	
  //GetValue(Integer('"'));
  //sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  //goto yylexReturn;

end;
4:
begin
{LINE 66 Symbols.l}
	
  GetValue(Strtoint('}'));
  //sym_val := StrToDate(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  //goto yylexReturn;

end;
5:
begin
{LINE 73 Symbols.l}
	
  //sym_val := StrToInt(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  //goto yylexReturn;

end;
6:
begin
{LINE 79 Symbols.l}
	
  //sym_val := StrToFloat(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  //goto yylexReturn;

end;
7:
begin
{LINE 85 Symbols.l}
	
  // Do nothing
end;


{LINE 375 c:/etc/yylex.pas}

 end;   //end of case
    
    YY_SCANNER;
    i := yyleng;
    //goto yy_again;			(* action fell though *)

  yy_reject:
    YY_SCANNER;
    i := yyoleng;			(* restore original yytext *)
    //inc(yyfmin);
    if yyfmin < yyfmax then
      goto yy_found		(* another final state, same length *)
    else
      goto yy_search;		(* try shorter yytext *)

  yy_more:
    YY_SCANNER;
    i := yyleng;
    if i > 0 then
      //yy_lastc := Integer(yytext[i-1]);
      yy_lastc:= StrtoInt(yytext[i-1]);

    goto yy_contin;

  yylexReturn:
    result := retval
//end;		{ end of yylex }  
 //end;
end;

procedure LoadSymbols(Symbols: TStrings; SymTab: TVariantSymbolTable;
  Errors: TStrings);
begin
  yy_reset;
  yyin := TMemoryStream.Create;
  yyout := TMemoryStream.Create;
  yyerr := TMemoryStream.Create;
  try
    Symbols.SaveToStream(yyin);
    yyin.Seek(0, soFromBeginning);
   { while (yylex <> 0) do begin
      if (sym_name = '') then
        yyerror('No symbol name provided.')
      else
        SymTab.CreateSymbol(UpperCase(sym_name), sym_val);
      sym_name := '';
    end; }
    yyerr.Seek(0, soFromBeginning);
    Errors.LoadFromStream(yyerr);
  finally
    yyin.Free; yyout.Free; yyerr.Free;
  end;
end;


function CloseDebuggerOutput: Integer; //cdecl; export;
begin
  {$ifdef FULDebug}
  WriteDebug('CloseDebuggerOutput - Enter');
  {$endif}
  EnterCriticalSection(csDebugger);
  try
    // Default to failure.
    result := UDF_FAILURE;
    // if I've indicated an actual handle, then close it
    try
      if hDebugger > 0 then
        CloseHandle(hDebugger)
      // if I've indicated STDOUT, then Free the console
      else if hDebugger = $FFFFFFFF then
        writeln('freeconsole');//FreeConsole;
    finally
      // Ensure that the debugger handle is 0.
      hDebugger := 0;
    end;
    // Indicate success.
    result := UDF_SUCCESS;
  finally
    LeaveCriticalSection(csDebugger);
    {$ifdef FULDebug}
    WriteDebug('CloseDebuggerOutput - Exit');
    {$endif}
  end;
end;

const
  szConsoleMsg = 'FreeUDFLib Debugger Console:' + #13 + #10 +
                 '  Press Ctrl-Enter to switch between full-screen and window.' +
                 #13 + #10 + #13 + #10;

{* Important notes regarding Debug:
   This function is meant only for its intended purpose.
   As you will note, I did not include mechanisms for many users
   to be cleanly dumping data to the debug window. Don't expect this
   function to perform as you might like if you have multiple users
   calling it! *}
function ADebug(szDebuggerOutput: PChar): Integer; //cdecl; export;
var
  hOutput: THandle;
  BytesWritten: DWORD;
  sOutput: String;
begin
  {$ifdef FULDebug}
  WriteDebug('Debug(' + String(szDebuggerOutput) + ') - Enter');
  {$endif}
  EnterCriticalSection(csDebugger);
  try
    // Default to failure.
    result := UDF_FAILURE;
    if hDebugger = 0 then exit;
    // -1 indicates STDOUT, so let's do just that
    if hDebugger = $FFFFFFFF then begin
      // Try to get STDOUT's handle.
      hOutput := GetStdHandle(STD_OUTPUT_HANDLE);
      // if I couldn't get STDOUT's handle, then AllocConsole probably needs
      // to be called.
      if hOutput = INVALID_HANDLE_VALUE then begin
        // Allocate a console.
        //AllocConsole;
        // Just check that everything went right, and put a friendly
        // message at the top of the console window.
        hOutput := GetStdHandle(STD_OUTPUT_HANDLE);
        if hOutput = INVALID_HANDLE_VALUE then exit;
   //WriteFile(hOutput, szConsoleMsg, StrLen(szConsoleMsg), BytesWritten, nil);
      end;
    end else
      hOutput := hDebugger;
    // Now, I can write my debugging stuff! whew.
    sOutput := String(szDebuggerOutput) + #13 + #10;
    //WriteFile(hOutput, sOutput[1], Length(sOutput), BytesWritten, nil);
    result := UDF_SUCCESS;
  finally
    LeaveCriticalSection(csDebugger);
    {$ifdef FULDebug}
    WriteDebug('Debug(' + String(szDebuggerOutput) + ') - Exit');
    {$endif}
  end;
end;

function IBTempPath: PChar;
begin
  {$ifdef FULDebug}
  WriteDebug('IBTempPath() - Enter');
  {$endif}
  //result := MakeResultString(StdFuncs.TempPath, nil, 0);
  result:= MakeResultString(ExePath, 'nil', 0);

  {$ifdef FULDebug}
  WriteDebug('IBTempPath() - Exit');
  {$endif}
end;

function SetDebuggerOutput(szOutputFile: PChar): Integer;
begin
  {$ifdef FULDebug}
  WriteDebug('SetDebuggerOutput(' + String(szOutputFile) + ') - Enter');
  {$endif}
  EnterCriticalSection(csDebugger);
  try
    // Default to failure.
    result := UDF_FAILURE;
    // If the user asked for STDOUT, then set the "new" handle to -1.
    if lstrcmpi(szOutputFile, 'STDOUT') = 0 then begin
      if (hDebugger > 0) then
        CloseDebuggerOutput;
      hDebugger := $FFFFFFFF;
    end else begin
      CloseDebuggerOutput;
      {//hDebugger:= CreateFile(szOutputFile, GENERIC_WRITE, 0, nil,
                                 CREATE_ALWAYS,
                                 FILE_ATTRIBUTE_NORMAL + FILE_FLAG_WRITE_THROUGH,
                                 0);
      }
      if hDebugger = INVALID_HANDLE_VALUE then
        hDebugger := 0;
    end;
    result := UDF_SUCCESS;
  finally
    LeaveCriticalSection(csDebugger);
    {$ifdef FULDebug}
    WriteDebug('SetDebuggerOutput(' + String(szOutputFile) + ') - Exit');
    {$endif}
  end;
end;

function ValidateCycleExpression(szCycleExpression: PChar;
  var ExprStart: Integer): Integer;
var
   strToken: String;
begin
  {$ifdef FULDebug}
  WriteDebug('ValidateCycleExpression - Enter');
  {$endif}
  result := 1;
  //strToken := FindTokenStartingAt(String(szCycleExpression), ExprStart,
    //                              WhiteSpace, False);
  if (Length(strToken) > 0) then begin
    case strToken[1] of
      '0'..'9': begin
        try
          StrToInt(strToken);
        except
          result := 0;
        end;
      end;
      '>': begin
        if (strToken[2] = '=') then begin
          Delete(strToken, 1, 2);
          try
            StrToInt(strToken);
          except
            result := 0;
          end;
        end else
          result := 0;
      end;  // '>'
      '$': begin
        Delete(strToken, 1, 1);
        try
          StrToFloat(strToken);
        except
          result := 0;
        end;
      end;  // '$'
      'A','a': begin
        if (Length(strToken) = 3) and
           ((strToken[2] = 'N') or (strToken[2] = 'n')) and
           ((strToken[3] = 'D') or (strToken[3] = 'd')) then
          Result := ValidateCycleExpression(szCycleExpression, ExprStart) and
                    ValidateCycleExpression(szCycleExpression, ExprStart)
        else
          result := 0;
      end; // and
      'O','o': begin
        if (Length(strToken) = 2) and
           ((strToken[2] = 'R') or (strToken[2] = 'r')) then
          Result := ValidateCycleExpression(szCycleExpression, ExprStart) and
                    ValidateCycleExpression(szCycleExpression, ExprStart)
        else
          result := 0;
      end; // or
      'N','n': begin
        if (Length(strToken) = 3) and
           ((strToken[2] = 'O') or (strToken[2] = 'o')) and
           ((strToken[3] = 'T') or (strToken[3] = 't')) then
          result := ValidateCycleExpression(szCycleExpression, ExprStart);
      end; // not
      else
        result := 0;
    end; // case szCycleExpression[ExprStart] of
  end else
     result := 0;
  {$ifdef FULDebug}
  WriteDebug('ValidateCycleExpression - Exit');
  {$endif}
end; // boolValidateCycleExpression


function EvaluateCycleExpression(szCycleExpression: PChar;
  var ExprStart: Integer; OldDate, NewDate: Tdatetime;//PISC_QUAD;
  var Amount: Double): Integer;
var
   AmountD: double;
   DateInt, AgeInt: integer;
   strToken, amountStr, dateStr: String;
begin
  {$ifdef FULDebug}
  WriteDebug('EvaluateCycleExpression - Enter');
  {$endif}
 //{ if (szCycleExpression{[0]} = '#0') then begin
   // result := 0;
    //exit;
  //end;
  result := 1;
  amountStr := '';
  dateStr := '';
  //strToken := FindTokenStartingAt(String(szCycleExpression), ExprStart,
    //                              WhiteSpace, False);
    amount:= MonthsBetween(OldDate, NewDate);
  case strToken[1] of
    '0'..'9': begin
      DateInt := StrToInt(strToken);
      AgeInt:= daysinperiod(OldDate, NewDate);
      if ((ageInt mod dateInt) <> 0) then
        result := 0;
    end;  // '0'..'9'
    '>': begin
      Delete(strToken, 1, 2);
      dateInt := StrToInt(strToken);
      ageInt := daysinperiod(OldDate, NewDate); //AgeInMonths(OldDate, NewDate);
      if (ageInt < dateInt) then
        result := 0;
    end;  // '>'
    '$': begin
      Delete(strToken, 1, 1);
      amountD := StrToFloat(strToken);
      if (Amount < amountD) then
        result := 0;
    end;  // '$'
    'a','A': begin
      if (EvaluateCycleExpression(szCycleExpression, ExprStart,
                OldDate, NewDate, Amount) = 1) and
         (EvaluateCycleExpression(szCycleExpression, ExprStart,
                OldDate, NewDate, Amount) = 1) then
        Result := 1
      else
        Result := 0;
    end; // and
    'o','O': begin
      if (EvaluateCycleExpression(szCycleExpression, ExprStart,
                OldDate, NewDate, Amount) = 1) or
         (EvaluateCycleExpression(szCycleExpression, ExprStart,
                OldDate, NewDate, Amount) = 1) then
        Result := 1
      else
        Result := 0;
    end; // or
    'n','N': begin
      result := 1 and EvaluateCycleExpression(szCycleExpression, ExprStart,
                        OldDate, NewDate, Amount);
    end; // not
    else
      result := 0;
  end; // case strToken[1] of
  {$ifdef FULDebug}
  WriteDebug('EvaluateCycleExpression - Exit');
  {$endif}
end; // EvaluateCycleExpression

function ValidateBillingExpression(szCycleExpression: PChar;
  var ExprStart: Integer): Integer;
begin
  {$ifdef FULDebug}
  WriteDebug('ValidateBillingExpression - Enter');
  {$endif}
  result := 1;
  {$ifdef FULDebug}
  WriteDebug('ValidateBillingExpression - Exit');
  {$endif}
end;

function EvaluateExpression(szExpr: PChar; szSymbols: PChar): PChar;
var
  slExpr, slErrors, slSymbols: TStrings;
  SymTab: TVariantSymbolTable;
  ExprParser: TExprParser;
begin
  {$ifdef FULDebug}
  WriteDebug('EvaluateExpression - Enter');
  {$endif}
  slExpr := TStringList.Create;
  slErrors := TStringList.Create;
  slSymbols := TStringList.Create;
  SymTab := TVariantSymbolTable.Create;
  try
    slSymbols.Text := String(szSymbols);
    (* Load the symbol table *)
    //Symbols.LoadSymbols(slSymbols, SymTab, slErrors);
    LoadSymbols(slSymbols, SymTab, slErrors);
  
    (* Parse and evalute the expression *)
    slExpr.Text := String(szExpr);
    {if ExprParser.EvaluateExpression(slExpr, SymTab, slErrors) then
      result := MakeResultString('TRUE', nil, 0)
    else
      result := MakeResultString('FALSE', nil, 0); }
  finally
    //if slErrors.Count > 0 then
      //result := MakeResultString(PChar(slErrors.Text), nil, 0);
    SymTab.Free;
    slExpr.Free;
    slErrors.Free;
    slSymbols.Free;
  end;
  {$ifdef FULDebug}
  WriteDebug('EvaluateExpression - Exit');
  {$endif}
end;

var
  afloat : extended;
  amount : Extended;
  s: string;
  fs : TFormatSettings; 

const AValue = 98765432.1;



initialization

  InitializeCriticalSection(csDebugger);
  // Set up our floating point number
  afloat := 1234.567;
  amount := 1234.56;

  writeln('initialize call')
  writeln(floattoStr(MonthsBetween(now, strtodatetime('6/20/1959'))))
  writeln(inttoStr(DaysinPeriod(now, strtodatetime('6/20/1959'))))
   
    maxcalcF('10^(log(36)/2)')
    writeln('SQRT with ln: '+floattoStr(power(Euler,ln(36)/2)))
    PrintF('SQRT with ln: %.2f ',[power(Euler,ln(36)/2)]); 
    maxcalcF('e^(ln(36)/2)')
    maxcalcF('ln(e)')
    maxcalcF('ln(1)')
    maxcalcF('e^0')
    
    GetLocaleFormatSettings(0, fs);
   fs.DecimalSeparator := 'D';
   fs.ThousandSeparator := 'T';
   
   s:= FloatToStrFS(100000 * PI, ffNumber,9,5,fs);
   writeln('GetLocaleFormatSettings Test: '+s)
   
   //s == '3T141T592D65'  or 314T159D26500
    
    writeln('ThousandSeparator: '+ThousandSeparator)
    writeln('DecimalSeparator: '+DecimalSeparator)
    
    writeln(FormatFloat('0',AValue));
    // '98765432'

   writeln(FormatFloat('###,###,###.0000',AValue));
   // '98.765.432,1000'   ---Diff in . or , as thousand sep.!
   // '98,765,432.1000'   ---Diff in . or , as thousand sep.!
   
   writeln(FormatFloat('"Number" #.00',AValue));
   // 'Number 98765432,10'
   
   writeln(FormatFloat('.,00',AValue));
   // '98.765.432,10'


finalization

  DeleteCriticalSection(csDebugger);
   maxcalcF('e^0')
   Writeln(FormatFloat('#.##0,00',1239845))
   Writeln(FormatFloat('#,##0.00',1239845))
   Writeln(FloatToStrF(1239845,ffnumber,10,2))
   maxcalcF('29*37*(127^-1)*179*(15749^-1)*2082607');
   maxcalcF('29*37*(1/127)*179*(1/15749)*2082607');
   
   // Display a sample value using all of the format options
   Writeln('')
  // Round out the decimal value
  //ShowMessage('##### : '+FormatFloat('#####', afloat));
  ShowMessage('##### : '+FormatFloat('#####', afloat));

  Writeln('##### : '+FormatFloat('#####', afloat));
  Writeln('00000 : '+FormatFloat('00000', afloat));
  Writeln('0     : '+FormatFloat('0'    , afloat));
  Writeln('#,##0 : '+FormatFloat('#,##0', afloat));
  Writeln(',0    : '+FormatFloat(',0'   , afloat));
  Writeln('');

  // Include the decimal value
  Writeln('0.#### : '+FormatFloat('0.####', afloat));
  Writeln('0.0000 : '+FormatFloat('0.0000', afloat));
  Writeln('');

  // Scientific format
  Writeln('0.0000000E+00 : '+FormatFloat('0.0000000E+00', afloat));
  Writeln('0.0000000E-00 : '+FormatFloat('0.0000000E-00', afloat));
  Writeln('#.#######E-## : '+FormatFloat('#.#######E-##', afloat));
  Writeln('');

  // Include freeform text
  Writeln('"Value = "0.0 : '+FormatFloat('"Value = "0.0', afloat));
  Writeln('');

  // Different formatting for negative numbers
  Writeln('0.0 : '+FormatFloat('0.0'              , -1234.567));
  Writeln('0.0 "CR";0.0 "DB" : '+
              FormatFloat('0.0 "CR";0.0 "DB"', -1234.567));
  Writeln('0.0 "CR";0.0 "DB" : '+
              FormatFloat('0.0 "CR";0.0 "DB"',  1234.567));
  Writeln('');

  // Different format for zero value
  Writeln('0.0 : '+FormatFloat('0.0' , 0.0));
  Writeln('0.0;-0.0;"Nothing" : '+
              FormatFloat('0.0;-0.0;"Nothing"', 0.0));
 
  Writeln('');
  Writeln('FloatToStrF');
            
  ShowMessage('General 4,0 = '+FloatToStrF(amount, ffGeneral, 4, 0));
  Writeln('General 6,0 = '+FloatToStrF(amount, ffGeneral, 6, 0));
  Writeln('General 6,2 = '+FloatToStrF(amount, ffGeneral, 6, 2));
  Writeln('General 3,2 = '+FloatToStrF(amount, ffGeneral, 3, 2));
  Writeln('');

  // Display using ffExponent formatting
  Writeln('Exponent 4,0 = '+FloatToStrF(amount, ffExponent, 4, 0));
  Writeln('Exponent 6,0 = '+FloatToStrF(amount, ffExponent, 6, 0));
  Writeln('Exponent 6,2 = '+FloatToStrF(amount, ffExponent, 6, 2));
  Writeln('Exponent 3,2 = '+FloatToStrF(amount, ffExponent, 3, 2));
  Writeln('');

  // Display using ffFixed formatting
  Writeln('Fixed 4,0 = '+FloatToStrF(amount, ffFixed, 4, 0));
  Writeln('Fixed 6,0 = '+FloatToStrF(amount, ffFixed, 6, 0));
  Writeln('Fixed 6,2 = '+FloatToStrF(amount, ffFixed, 6, 2));
  Writeln('Fixed 3,2 = '+FloatToStrF(amount, ffFixed, 3, 2));
  Writeln('');

  // Display using ffNumber formatting
  Writeln('Number 4,0 = '+FloatToStrF(amount, ffNumber, 4, 0));
  Writeln('Number 6,0 = '+FloatToStrF(amount, ffNumber, 6, 0));
  Writeln('Number 6,2 = '+FloatToStrF(amount, ffNumber, 6, 2));
  Writeln('Number 3,2 = '+FloatToStrF(amount, ffNumber, 3, 2));
  Writeln('');

  // Display using ffCurrency formatting
  Writeln('Currency 4,0 = '+FloatToStrF(amount, ffCurrency, 4, 0));
  Writeln('Currency 6,0 = '+FloatToStrF(amount, ffCurrency, 6, 0));
  Writeln('Currency 6,2 = '+FloatToStrF(amount, ffCurrency, 6, 2));
  Writeln('Currency 3,2 = '+FloatToStrF(amount, ffCurrency, 3, 2));
           
  //1,239,845.00
//begin  

End.

Ref:

type TFloatFormat = (ffGeneral, ffExponent, ffFixed, ffNumber, ffCurrency); 

http://www.delphibasics.co.uk/RTL.asp?Name=FormatFloat
http://www.delphibasics.co.uk/RTL.asp?Name=TFloatFormat


   ##### : 1235
   00000 : 01235
   0     : 1235
   #,##0 : 1,235
   ,0    : 1,235
  
   0.#### : 1234.567
   0.0000 : 1234.5670
  
   0.0000000E+00 : 1.2345670E+03
   0.0000000E-00 : 1.2345670E03
   #.#######E-## : 1.234567E3
  
   "Value = " : Value = 1234.6
  
   0.0 : -1234.6
   0.0 "CR";0.0 "DB" : 1234.6 DB
   0.0 "CR";0.0 "DB" : 1234.6 CR
  
   0.0 : 0.0
   0.0;-0.0;"Nothing" : Nothing
   
   TFloatFormat  - FloatToStrF
   
   General 4,0 = 1235
   General 6,0 = 1234.56
   General 6,2 = 1234.56
   General 3,2 = 1.23E03
  
   Exponent 4,0 = 1.235E+3
   Exponent 6,0 = 1.23456E+3
   Exponent 6,2 = 1.23456E+03
   Exponent 3,2 = 1.23E+03
  
   Fixed 4,0 = 1235
   Fixed 6,0 = 1235
   Fixed 6,2 = 1234.56
   Fixed 3,2 = 1.23E03
  
   Number 4,0 = 1,235
   Number 6,0 = 1,235
   Number 6,2 = 1,234.56
   Number 3,2 = 1.23E03
  
   Currency 4,0 = ?1,235
   Currency 6,0 = ?1,235
   Currency 6,2 = ?1,234.56
   Currency 3,2 = 1.23E03
   
   
   
   function FormatFloat(const Format: string; Value: Extended): string; overload;
function FormatFloat(const Format: string; Value: Extended; const FormatSettings: TFormatSettings): string; overload;

description
Returns a string from a floating point value using the provided format string.

The second form of FormatFloat, refers to localization information contained in the FormatSettings parameter.

Format specifiers supported in the format string are:
0 Digit place holder.
# Digit placeholder.
. Decimal point.
, Thousand separator.
E+ Scientific notation.
'xx'/"xx" Characters enclosed in single or double quotes are output as-is.
; Separates sections for positive, negative, and zero numbers in the format string. 


(*
 * The actual lexical scanner
 *)
function yylex : integer;

{LINE 230 c:/etc/yylex.pas}

var
	retval, c, i, yyst, yybase: integer;
	yyfmin, yyfmax: integer;	(* yy_la_act index of final states *)
	yyoldi, yyoleng: integer;	(* base i, yyleng before look-ahead *)
	yyeof: integer;			(* 1 if eof has already been read *)
label
	yy_again,
	yy_contin,
	yy_jammed,
	yy_search,
	yy_found,
	done_loop,
	loop_exit,
	yy_reject,
	yy_more,
	yylexReturn;

begin
  yyLexFatal := 0;
  yyeof := 0;
  i := yyleng;
  YY_SCANNER;

  yy_again:
    yyleng := i;
    (* determine previous char. *)
    if i > 0 then
      yy_lastc := Integer(yytext[i-1]);
    (* scan previously accepted token adjusting yylineno *)
    while (i > 0) do begin
      dec(i);
      if Integer(yytext[i]) = YYNEWLINE then
        inc(yylineno)
    end;
    (* adjust pushback *)
    dec(yy_end, yyleng);
    for i := 0 to yy_end - 1 do
      yytext[i] := yytext[yyleng + i];
    i := 0;
  yy_contin:
    yyoldi := i;

    (* run the state machine until it jams *)
    if yy_lastc = YYNEWLINE then
      yyst := tblyy_begin[yy_start + 1]
    else
      yyst := tblyy_begin[yy_start];
    yy_sbuf[i] := yyst;

    repeat
      if i >= YYLMAX then begin
        YY_FATAL('Token buffer overflow');
	if yyLexFatal = 1 then begin
	  retval := -2;
	  goto yylexReturn;
        end;
      end;
      (* get input char *)
      if i < yy_end then
        c := Integer(yytext[i])    (* get pushback char *)
      else begin
      	if yyeof = 0 then
	  c := yygetc
        else
	  c := -1;
        if c <> -1 then begin
          yy_end := i+1;
	  yytext[i] := chr(c)
        end else begin	(* end of file *)
          if i = yyoldi then begin
            yyeof := 0;
	    if yywrap <> 0 then begin
              retval := 0;
              goto yylexReturn
            end else
              goto yy_again
          end else begin
            yyeof := 1;	(* don't re-read EOF *)
            goto loop_exit
          end
        end
      end;
      (* look up next state *)
      yybase := tblyy_base[yyst] + c;
      while (yybase > yy_nxtmax) or (tblyy_check[yybase] <> yyst) do begin
        if yyst = yy_endst then
          goto yy_jammed;
        yyst := tblyy_default[yyst];
        yybase := tblyy_base[yyst] + c
      end;
      yyst := tblyy_next[yybase];

    yy_jammed:
      inc(i);
      yy_sbuf[i] := yyst
    until (yyst = yy_endst) or (YY_INTERACTIVE <> 0) and
          (tblyy_base[yyst] > yy_nxtmax) and
          (tblyy_default[yyst] = yy_endst) ;

  loop_exit:
    if yyst <> yy_endst then
      inc(i);

  yy_search:
    (* search backward for a final state *)
    dec(i);
    while i > yyoldi do begin
      yyst := yy_sbuf[i];
      yyfmin := tblyy_final[yyst];
      yyfmax := tblyy_final[yyst+1];
      if yyfmin < yyfmax then
        goto yy_found;	(* found final state(s) *)
      dec(i);
    end;
    (* no match, default action *)
    i := yyoldi + 1;
    output(char(yytext[yyoldi]));
    goto yy_again;

  yy_found:
    yyoleng := i;		(* save length for REJECT *)
    (* pushback look-ahead RHS *)
    c := (integer(tblyy_la_act[yyfmin]) shr 9) - 1;

    if c >= 0 then begin		(* trailing context? *)
      while true do begin
        dec(i);
        if i < yyoldi then begin
          i := yyoleng;
          goto done_loop
        end else begin
          yyst := yy_sbuf[i];
          if ((tblyy_look[c*YY_LA_SIZE+word(yyst) div 8] and
               yybits[word(yyst) mod 8]) <> 0) then
            goto done_loop;
        end
      end;
    done_loop:
    end;

    (* perform action *)
    yyleng := i;
    YY_USER;
    case (tblyy_la_act[yyfmin] and $1FF) of
0:
begin
{LINE 45 Symbols.l}
	
  sym_name := String(yytext);
  YYBEGIN(YYSYMBOL_VALUE);


end;
1:
begin
{LINE 49 Symbols.l}
	
  // Do nothing with whitespace


end;
2:
begin
{LINE 52 Symbols.l}
	
  GetValue(Integer(''''));
  sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
3:
begin
{LINE 59 Symbols.l}
	
  GetValue(Integer('"'));
  sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
4:
begin
{LINE 66 Symbols.l}
	
  GetValue(Integer('}'));
  sym_val := StrToDate(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
5:
begin
{LINE 73 Symbols.l}
	
  sym_val := StrToInt(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
6:
begin
{LINE 79 Symbols.l}
	
  sym_val := StrToFloat(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
7:
begin
{LINE 85 Symbols.l}
	
  // Do nothing


end;

{LINE 375 c:/etc/yylex.pas}

    end;
    YY_SCANNER;
    i := yyleng;
    goto yy_again;			(* action fell though *)

  yy_reject:
    YY_SCANNER;
    i := yyoleng;			(* restore original yytext *)
    inc(yyfmin);
    if yyfmin < yyfmax then
      goto yy_found		(* another final state, same length *)
    else
      goto yy_search;		(* try shorter yytext *)

  yy_more:
    YY_SCANNER;
    i := yyleng;
    if i > 0 then
      yy_lastc := Integer(yytext[i-1]);
    goto yy_contin;

yylexReturn:
    result := retval
end;		{ end of yylex }  



(* lex -LP -o Symbols.pas Symbols.l *)
{LINE 1 Symbols.l}


//**********************************************3

unit Symbols;
{$DEFINE YYIOSTREAMED}

interface

uses
  Windows, Classes, SysUtils, StdFuncs, StdConsts, VariantSymbolTable;

{$DEFINE YYLMAX_DEFINED}
const
  yylmax = 1023;
  yylmax1 = yylmax + 1;

procedure GetValue(delim: Integer);
procedure LoadSymbols(Symbols: TStrings; SymTab: TVariantSymbolTable;
  Errors: TStrings);
procedure yyerror(msg: String);
function yylex: Integer;

threadvar
  yyin, yyout, yyerr: TStream;
  sym_name: String;
  sym_val: Variant;

implementation

procedure yyerror(msg: String);
begin
  msg := msg + CRLF;
  yyerr.WriteBuffer(msg[1], Length(msg));
end;
type
	yy_state_t = byte;
const
	YYNEWLINE = 10;
	INITIAL = 0;
	YYSYMBOL_VALUE = 2;
const
	yy_endst = 15;
	yy_nxtmax = 314;

{LINE 1 c:/etc/yylex.pas}
(*
 * 2/5/1998 - Gregory Deatz
 * gdeatz(at)hlmdd.com
 *
 * YYPARSE.PAS - A thread-safe version modified from the
 * template files distributed with MKS lex/yacc 3.2b.
 *
 * I guess MKS's copyright still stands, because I didn't change much,
 * but it would be nice if you acknowledged work where work was
 * done....
*)
(*
 * Copyright 1990, 1991 by Mortice Kern Systems Inc.
 * All rights reserved.
 *)
//{$B-}		(* short circuit boolean evaluation *)
//{$I-}           (* suppress I/O runtime library checks *)
//{$J-}           (* Don't allow assignable constants *)

const
	YY_LA_SIZE = 2;

type tableyy_la_act = array[0..10] of word;
var yy_la_act: ^tableyy_la_act;
const tblyy_la_act: tableyy_la_act = (
 1, 0, 2, 3, 4, 5, 7, 6, 6, 5, 0
);

type tableyy_look = array[0..0] of byte;
var yy_look: ^tableyy_look;
const tblyy_look: tableyy_look = (
 0
);

type tableyy_final = array[0..15] of integer;
var yy_final: ^tableyy_final;
const tblyy_final: tableyy_final = (
 0, 0, 0, 1, 2, 2, 3, 4, 5, 5, 5, 6, 7, 8, 9, 10

);

type tableyy_begin = array[0..4] of yy_state_t;
var yy_begin: ^tableyy_begin;
const tblyy_begin: tableyy_begin = (
 0, 0, 4, 4, 0
);

type tableyy_next = array[0..315] of yy_state_t;
var yy_next: ^tableyy_next;
const tblyy_next: tableyy_next = (
 15, 15, 15, 15, 15, 15, 15, 15, 15, 2, 2, 2, 2, 2, 15, 2,
 11, 11, 15, 15, 11, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
 2, 15, 2, 15, 15, 15, 15, 11, 15, 15, 15, 15, 15, 15, 1, 12,
 15, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 15, 15, 15, 15, 15,
 15, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 15, 15, 15, 15, 1,
 15, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 15, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 15, 15, 15, 15, 15, 15, 15, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 15, 15, 15, 15, 3, 15, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 11, 11, 15, 15, 11, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 15, 15, 15, 15, 15, 15, 15, 15, 11,
 15, 6, 15, 8, 15, 15, 5, 15, 15, 15, 15, 15, 9, 15, 15, 10,
 10, 10, 10, 10, 10, 10, 10, 10, 10, 14, 14, 14, 14, 14, 14, 14,
 14, 14, 14, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 7, 0
);

type tableyy_check = array[0..315] of yy_state_t;
var yy_check: ^tableyy_check;
const tblyy_check: tableyy_check = (
 $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, 0, 0, 2, 2, 0, $FF, 2,
 11, 11, $FF, $FF, 11, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF,
 0, $FF, 2, $FF, $FF, $FF, $FF, 11, $FF, $FF, $FF, $FF, $FF, $FF, 0, 10,
 9, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, $FF, $FF, $FF, $FF, $FF,
 $FF, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, $FF, $FF, $FF, $FF, 0,
 $FF, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, $FF, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, $FF, $FF, $FF, $FF, $FF, $FF, $FF, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, $FF, $FF, $FF, $FF, 1, $FF, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 4, 4, $FF, $FF, 4, 12, 12, 12,
 12, 12, 12, 12, 12, 12, 12, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, 4,
 $FF, 4, $FF, 4, $FF, $FF, 4, $FF, $FF, $FF, $FF, $FF, 4, $FF, $FF, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 8,
 8, 8, 8, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF,
 $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF,
 $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF,
 $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, 4, 0
);

type tableyy_default = array[0..15] of yy_state_t;
var yy_default: ^tableyy_default;
const tblyy_default: tableyy_default = (
 15, 15, 15, 1, 15, 15, 15, 15, 15, 10, 15, 15, 15, 12, 8, 0

);

type tableyy_base = array[0..15] of integer;
var yy_base: ^tableyy_base;
const tblyy_base: tableyy_base = (
 0, 77, 2, 315, 191, 315, 315, 315, 201, 2, 1, 7, 157, 315, 315, 315

);


{LINE 21 c:/etc/yylex.pas}


(*
 * the following can be redefined by the user.
 *)
{$IFNDEF YYLMAX_DEFINED}
{$DEFINE YYLMAX_DEFINED}
const
  YYLMAX = 100;		(* token and pushback buffer size *)
  YYLMAX1 = 101;    	(**** always 1 more then YYLMAX ****)
{$ENDIF}

(*
 * yy_sbuf[0:yyleng-1] contains the states corresponding to yytext.
 * yytext[0:yyleng-1] contains the current token.
 * yytext[yyleng:yy_end-1] contains pushed-back characters.
 * When the user action routine is active,
 * yy_save contains yytext[yyleng], which is set to '\0'.
 * Things are different when YY_PRESERVE is defined.
 * YYFILE_EXTERNAL allows the definition of yyin and yyout in
 * other modules of your Pascal project based on lex output
 *)
var
   cs_globs :  TRTLCriticalSection;

threadvar
{$IFNDEF YYTEXT_BUF_EXTERNAL}
	yytext: array[0..YYLMAX1] of char; (* text buffer (really yytext) *)
{$ENDIF}
	yy_sbuf: array[0..YYLMAX1] of yy_state_t;	(* state buffer *)
{$IFNDEF YYIOSTREAMED}
{$IFNDEF YYFILE_EXTERNAL}
	yyin,
	yyout,
        yyerr: text;
{$ENDIF}
{$ENDIF}
	yyLexFatal: integer;

const
  YY_INTERACTIVE = 1;  (* bit faster if 0 *)
  yybits: array[0..7] of Byte = (1, 2, 4, 8, 16, 32, 64, 128);

threadvar
  yylineno,
  yyleng,
  yy_end,
  yy_start,
  yy_lastc: Integer;
  yy_save: char;		(* saved yytext[yyleng] *)

(* Need a definition for yywrap to compile
 * Either issue 'use wrap' after compiling /lib/yywrap.pas,
 * or uncomment the following simple definition:
 *)
{$IFNDEF YYWRAP_EXTERNAL}
function yywrap: integer;
begin
  yywrap := 1;
end;
{$ENDIF}

(* built-in functions for yylex *)

function input: integer; forward;
procedure unput(c: integer); forward;

procedure ECHO (msg: string);
begin
{$IFNDEF YYIOSTREAMED}
  write(yyout, msg);
{$ELSE}
  yyout.WriteBuffer(msg[1], Length(msg));
{$ENDIF}
end;

(*
 * yygetc: return next character from input
 * Turbo Pascal seems to have a bug in release 4.0
 * wherein Eof(yyin) fails after ^Z is typed on a terminal read
 * Suppress runtime library checking and do our own.
 *)
function yygetc : integer;
var
  ch: char;
begin
{$IFNDEF YYIOSTREAMED}
  if not EOF(yyin) then begin
    Read(yyin, ch);
    if IOResult <> 0 then
      result := -1
    else
      result := ord(ch)
  end else
    result := -1
{$ELSE}
  (* Read the input from TStream object *)
  if yyin.Position < yyin.Size then begin
    yyin.ReadBuffer(ch, 1);
    result := Ord(ch);
  end else
    result := -1;
{$ENDIF}
end;

procedure output(c: char);
begin
{$IFNDEF YYIOSTREAMED}
  write(yyout, c);
{$ELSE}
  yyout.WriteBuffer(c, 1);
{$ENDIF}
end;

procedure YY_FATAL (msg: string);
begin
{$IFNDEF YYIOSTREAMED}
  writeln(yyerr, 'yylex: ',msg);
{$ELSE}
  msg := msg + #13 + #10;
  yyout.WriteBuffer(msg[1], Length(msg));
{$ENDIF}
  yyLexFatal := 1;
end;

procedure YY_INIT;
begin
  yy_start := 0;
  yyleng := 0;
  yy_end := 0;
  yy_lastc := YYNEWLINE
end;

procedure yy_reset;
begin
  YY_INIT;
  yylineno := 1;
end;

procedure YYBEGIN (state: integer);
begin
  yy_start := state
end;

procedure NLSTATE;
begin
  yy_lastc := YYNEWLINE
end;

(*
 * the following must not be redefined.
 *)
procedure YY_SCANNER; forward;
procedure YY_USER; forward;

procedure YY_USER;	(* set up yytext for user *)
begin
  yy_save := yytext[yyleng];
  yytext[yyleng] := Char(0)
end;

procedure YY_SCANNER;	(* set up yytext for scanner *)
begin
  yytext[yyleng] := yy_save
end;

procedure yyless (n: integer);
begin
  if (n >= 0) and (n <= yy_end) then begin
    YY_SCANNER;
    yyleng := n;
    YY_USER
  end
end;

(* The following (yycomment) can be changed *)

(*
 * yycomment(trailing-comment-string)
 *	skip comment input, accounting for newlines
 *)
procedure yycomment (mat: string);
var
  c:	integer;
  icp:	integer;
  done:	boolean;
begin
  icp := 1;
  done := false;
  while (icp <= length(mat)) and (not done) do begin
    c := input;
    if c = -1 then begin
      YY_FATAL('end of file in comment');
      done := true
    end else if c <> ord(mat[icp]) then begin
      if c = ord(mat[1]) then
        icp := 2
      else
        icp := 1;
    end else
      inc(icp)
  end;
end;


(*
 * The actual lexical scanner
 *)
function yylex : integer;

{LINE 230 c:/etc/yylex.pas}

var
	retval, c, i, yyst, yybase: integer;
	yyfmin, yyfmax: integer;	(* yy_la_act index of final states *)
	yyoldi, yyoleng: integer;	(* base i, yyleng before look-ahead *)
	yyeof: integer;			(* 1 if eof has already been read *)
label
	yy_again,
	yy_contin,
	yy_jammed,
	yy_search,
	yy_found,
	done_loop,
	loop_exit,
	yy_reject,
	yy_more,
	yylexReturn;

begin
  yyLexFatal := 0;
  yyeof := 0;
  i := yyleng;
  YY_SCANNER;

  yy_again:
    yyleng := i;
    (* determine previous char. *)
    if i > 0 then
      yy_lastc := Integer(yytext[i-1]);
    (* scan previously accepted token adjusting yylineno *)
    while (i > 0) do begin
      dec(i);
      if Integer(yytext[i]) = YYNEWLINE then
        inc(yylineno)
    end;
    (* adjust pushback *)
    dec(yy_end, yyleng);
    for i := 0 to yy_end - 1 do
      yytext[i] := yytext[yyleng + i];
    i := 0;
  yy_contin:
    yyoldi := i;

    (* run the state machine until it jams *)
    if yy_lastc = YYNEWLINE then
      yyst := tblyy_begin[yy_start + 1]
    else
      yyst := tblyy_begin[yy_start];
    yy_sbuf[i] := yyst;

    repeat
      if i >= YYLMAX then begin
        YY_FATAL('Token buffer overflow');
	if yyLexFatal = 1 then begin
	  retval := -2;
	  goto yylexReturn;
        end;
      end;
      (* get input char *)
      if i < yy_end then
        c := Integer(yytext[i])    (* get pushback char *)
      else begin
      	if yyeof = 0 then
	  c := yygetc
        else
	  c := -1;
        if c <> -1 then begin
          yy_end := i+1;
	  yytext[i] := chr(c)
        end else begin	(* end of file *)
          if i = yyoldi then begin
            yyeof := 0;
	    if yywrap <> 0 then begin
              retval := 0;
              goto yylexReturn
            end else
              goto yy_again
          end else begin
            yyeof := 1;	(* don't re-read EOF *)
            goto loop_exit
          end
        end
      end;
      (* look up next state *)
      yybase := tblyy_base[yyst] + c;
      while (yybase > yy_nxtmax) or (tblyy_check[yybase] <> yyst) do begin
        if yyst = yy_endst then
          goto yy_jammed;
        yyst := tblyy_default[yyst];
        yybase := tblyy_base[yyst] + c
      end;
      yyst := tblyy_next[yybase];

    yy_jammed:
      inc(i);
      yy_sbuf[i] := yyst
    until (yyst = yy_endst) or (YY_INTERACTIVE <> 0) and
          (tblyy_base[yyst] > yy_nxtmax) and
          (tblyy_default[yyst] = yy_endst) ;

  loop_exit:
    if yyst <> yy_endst then
      inc(i);

  yy_search:
    (* search backward for a final state *)
    dec(i);
    while i > yyoldi do begin
      yyst := yy_sbuf[i];
      yyfmin := tblyy_final[yyst];
      yyfmax := tblyy_final[yyst+1];
      if yyfmin < yyfmax then
        goto yy_found;	(* found final state(s) *)
      dec(i);
    end;
    (* no match, default action *)
    i := yyoldi + 1;
    output(char(yytext[yyoldi]));
    goto yy_again;

  yy_found:
    yyoleng := i;		(* save length for REJECT *)
    (* pushback look-ahead RHS *)
    c := (integer(tblyy_la_act[yyfmin]) shr 9) - 1;

    if c >= 0 then begin		(* trailing context? *)
      while true do begin
        dec(i);
        if i < yyoldi then begin
          i := yyoleng;
          goto done_loop
        end else begin
          yyst := yy_sbuf[i];
          if ((tblyy_look[c*YY_LA_SIZE+word(yyst) div 8] and
               yybits[word(yyst) mod 8]) <> 0) then
            goto done_loop;
        end
      end;
    done_loop:
    end;

    (* perform action *)
    yyleng := i;
    YY_USER;
    case (tblyy_la_act[yyfmin] and $1FF) of
0:
begin
{LINE 45 Symbols.l}
	
  sym_name := String(yytext);
  YYBEGIN(YYSYMBOL_VALUE);


end;
1:
begin
{LINE 49 Symbols.l}
	
  // Do nothing with whitespace


end;
2:
begin
{LINE 52 Symbols.l}
	
  GetValue(Integer(''''));
  sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
3:
begin
{LINE 59 Symbols.l}
	
  GetValue(Integer('"'));
  sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
4:
begin
{LINE 66 Symbols.l}
	
  GetValue(Integer('}'));
  sym_val := StrToDate(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
5:
begin
{LINE 73 Symbols.l}
	
  sym_val := StrToInt(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
6:
begin
{LINE 79 Symbols.l}
	
  sym_val := StrToFloat(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
7:
begin
{LINE 85 Symbols.l}
	
  // Do nothing


end;

{LINE 375 c:/etc/yylex.pas}

    end;
    YY_SCANNER;
    i := yyleng;
    goto yy_again;			(* action fell though *)

  yy_reject:
    YY_SCANNER;
    i := yyoleng;			(* restore original yytext *)
    inc(yyfmin);
    if yyfmin < yyfmax then
      goto yy_found		(* another final state, same length *)
    else
      goto yy_search;		(* try shorter yytext *)

  yy_more:
    YY_SCANNER;
    i := yyleng;
    if i > 0 then
      yy_lastc := Integer(yytext[i-1]);
    goto yy_contin;

yylexReturn:
    result := retval
end;		{ end of yylex }

(*
 * user callable input/unput functions.
 *)
(* get input char with pushback *)
function input: integer;
var
  c: integer;
begin
  if yy_end > yyleng then begin
    dec(yy_end);
    for c := 0 to yy_end-yyleng-1 do
      yytext[yyleng+c] := yytext[yyleng+1+c];
    c := ord(yy_save);
    YY_USER;
  end else
    c := yygetc;
  yy_lastc := c;
  if c = YYNEWLINE then
    inc(yylineno);
  result := c;
end;

(* pushback char *)
procedure unput(c: integer);
var
  i: word;
begin
  if yy_end >= YYLMAX then
    YY_FATAL('Push-back buffer overflow')
  else begin
    if yy_end > yyleng then begin
      yytext[yyleng] := yy_save;
      for i := 0 to yy_end - yyleng - 1 do
        yytext[yyleng+i+1] := yytext[yyleng];
      yytext[yyleng] := Char(0);
    end;
    inc(yy_end);
    yy_save := chr(c);

    if c = YYNEWLINE then
      dec(yylineno);
  end;
end;

procedure yylex_initialization;
begin
  InitializeCriticalSection(cs_globs);
  yy_reset;
end;

procedure yylex_finalization;
begin
  DeleteCriticalSection(cs_globs);
end;

{LINE 89 Symbols.l}

procedure GetValue(delim: Integer);
var
  ch, i: Integer;
begin
  ch := input;
  i := 0;
  while ((ch > 0) and (i < yylmax1)) do begin
    if (ch = delim) then begin
      ch := input;
      if (ch <> delim) then begin
        unput(ch);
	break;
      end;
    end;
    yytext[i] := Char(ch);
    Inc(i);
    ch := input;
  end;
  if (ch <= 0) then
    yyerror('EOF detected in symbol value');
  if (i = yylmax1) then
    yyerror('String too long');
  yytext[i] := #0;
end;

procedure LoadSymbols(Symbols: TStrings; SymTab: TVariantSymbolTable;
  Errors: TStrings);
begin
  yy_reset;
  yyin := TMemoryStream.Create;
  yyout := TMemoryStream.Create;
  yyerr := TMemoryStream.Create;
  try
    Symbols.SaveToStream(yyin);
    yyin.Seek(0, soFromBeginning);
    while (yylex <> 0) do begin
      if (sym_name = '') then
        yyerror('No symbol name provided.')
      else
        SymTab.CreateSymbol(UpperCase(sym_name), sym_val);
      sym_name := '';
    end;
    yyerr.Seek(0, soFromBeginning);
    Errors.LoadFromStream(yyerr);
  finally
    yyin.Free; yyout.Free; yyerr.Free;
  end;
end;

initialization

  yylex_initialization;

finalization

  yylex_finalization;

end.



SpecialBuild
mX4

LegalTrademarks
maXbox

SubsystemVersion
4.0

Comments
reduce to the max

LinkerVersion
2.25

ImageVersion
0.0

FileSubtype
0

FileVersionNumber
3.9.9.195

LanguageCode
German (Swiss)

FileFlagsMask
0x003f


Magic literal
PE32 executable for MS Windows (GUI) Intel 80386 32-bit

TrID 	Win32 Executable Borland Delphi 7 (51.3%)
Win32 Executable Borland Delphi 5 (34.8%)
Inno Setup installer (8.4%)
InstallShield setup (3.3%)
Win32 Executable Delphi generic (1.0%)

(*function yylex : integer;

{LINE 230 c:/etc/yylex.pas}

var
	retval, c, i, yyst, yybase: integer;
	yyfmin, yyfmax: integer;	//(* yy_la_act index of final states *)
	yyoldi, yyoleng: integer;	//(* base i, yyleng before look-ahead *)
	yyeof: integer;			//7/(* 1 if eof has already been read *)
	var 	tblyy_begin: tableyy_begin;
	  tblyy_base: tableyy_base;
	  tblyy_check: tableyy_check;

label
	yy_again,
	yy_contin,
	yy_jammed,
	yy_search,
	yy_found,
	done_loop,
	loop_exit,
	yy_reject,
	yy_more,
	yylexReturn;

begin
  yyLexFatal := 0;
  yyeof := 0;
  i := yyleng;
  YY_SCANNER;

  yy_again:
    yyleng := i;
    (* determine previous char. *)
    if i > 0 then
      yy_lastc:= strtoint(yytext[i-1]);
    (* scan previously accepted token adjusting yylineno *)
    while (i > 0) do begin
      dec(i);
   {   if Inttostr(yytext[i]) = YYNEWLINE then
        inc(yylineno)
    end;}
    
    (* adjust pushback *)
    dec1(yy_end, yyleng);
    for i := 0 to yy_end - 1 do
      yytext[i] := yytext[yyleng + i];
    i := 0;
  yy_contin:
    yyoldi := i;

    (* run the state machine until it jams *)
    if yy_lastc = YYNEWLINE then
      yyst := tblyy_begin[yy_start + 1]
    else
      yyst := tblyy_begin[yy_start];
    yy_sbuf[i] := yyst;

    repeat
      if i >= YYLMAX then begin
        writeln('//YY_FATAL(''Token buffer overflow'');')
	if yyLexFatal = 1 then begin
	  retval := -2;
	  goto yylexReturn;
        end;
      end;
      (* get input char *)
      if i < yy_end then
        c := strtoint(yytext[i])    (* get pushback char *)
      else begin
      	if yyeof = 0 then
	  c := yygetc
        else
	  c := -1;
        if c <> -1 then begin
          yy_end := i+1;
	  yytext[i] := chr(c)
        end else begin	(* end of file *)
          if i = yyoldi then begin
            yyeof := 0;
	    if yywrap <> 0 then begin
              retval := 0;
              goto yylexReturn
            end else
              goto yy_again
          end else begin
            yyeof := 1;	(* don't re-read EOF *)
            goto loop_exit
          end
        end
      end;
      (* look up next state *)
      yybase := tblyy_base[yyst] + c;
      while (yybase > yy_nxtmax) or (tblyy_check[yybase] <> yyst) do begin
        if yyst = yy_endst then
          goto yy_jammed;
        yyst := 1; //tblyy_default[yyst];
        yybase := tblyy_base[yyst] + c
      end;
      //(/yyst := tblyy_next[yybase];

    yy_jammed:
      inc(i);
      yy_sbuf[i] := yyst
      end;
     //end; 
    until (yyst = yy_endst) or (YY_INTERACTIVE <> 0) and
          (tblyy_base[yyst] > yy_nxtmax); {and
          (tblyy_default[yyst] = yy_endst)} //;

  loop_exit:
    if yyst <> yy_endst then
      inc(i);

  yy_search:
    (* search backward for a final state *)
    dec(i);
    while i > yyoldi do begin
      yyst := yy_sbuf[i];
      yyfmin := tblyy_final[yyst];
      yyfmax := tblyy_final[yyst+1];
      if yyfmin < yyfmax then
        goto yy_found;	(* found final state(s) *)
      dec(i);
    end;
    (* no match, default action *)
    i := yyoldi + 1;
    output(char(yytext[yyoldi]));
    goto yy_again;

  yy_found:
    yyoleng := i;		(* save length for REJECT *)
    (* pushback look-ahead RHS *)
    c := (integer(tblyy_la_act[yyfmin]) shr 9) - 1;

    if c >= 0 then begin		(* trailing context? *)
      while true do begin
        dec(i);
        if i < yyoldi then begin
          i := yyoleng;
          goto done_loop
        end else begin
          yyst := yy_sbuf[i];
          if ((tblyy_look[c*YY_LA_SIZE+word(yyst) div 8] and
               yybits[word(yyst) mod 8]) <> 0) then
            goto done_loop;
        end
      end;
    done_loop:
    end;

    (* perform action *)
    yyleng := i;
    YY_USER;
    case (tblyy_la_act[yyfmin] and $1FF) of
0:
begin
{LINE 45 Symbols.l}
	
  sym_name := String(yytext);
  YYBEGIN(YYSYMBOL_VALUE);


end;
1:
begin
{LINE 49 Symbols.l}
	
  // Do nothing with whitespace


end;
2:
begin
{LINE 52 Symbols.l}
	
  GetValue(Integer(''''));
  sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
3:
begin
{LINE 59 Symbols.l}
	
  GetValue(Integer('"'));
  sym_val := String(yytext);
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
4:
begin
{LINE 66 Symbols.l}
	
  GetValue(Integer('}'));
  sym_val := StrToDate(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
5:
begin
{LINE 73 Symbols.l}
	
  sym_val := StrToInt(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
6:
begin
{LINE 79 Symbols.l}
	
  sym_val := StrToFloat(String(yytext));
  YYBEGIN(INITIAL);
  retval := 1;
  goto yylexReturn;


end;
7:
begin
{LINE 85 Symbols.l}
	
  // Do nothing


end;

{LINE 375 c:/etc/yylex.pas}

    end;
    YY_SCANNER;
    i := yyleng;
    goto yy_again;			(* action fell though *)

  yy_reject:
    YY_SCANNER;
    i := yyoleng;			(* restore original yytext *)
    inc(yyfmin);
    if yyfmin < yyfmax then
      goto yy_found		(* another final state, same length *)
    else
      goto yy_search;		(* try shorter yytext *)

  yy_more:
    YY_SCANNER;
    i := yyleng;
    if i > 0 then
      yy_lastc := Integer(yytext[i-1]);
    goto yy_contin;

yylexReturn:
    result := retval
end;		{ end of yylex }  


Sehr geehrte Damen und Herren,

durch meine langjhrige Berufspraxis im Vertriebsinnendienst sowie meinen Kenntnissen in der Kundenbetreuung und Sachbearbeitung sehe ich eine gute Grundlage geschaffen, Ihr Unternehmen tatkrftig zu untersttzen und freue mich auf eine neue Herausforderung.

Da ich gerne wieder im Vertriebsinnendienst oder in der Sachbearbeitung ttig werden mchte, suche ich den beruflichen Neubeginn. Dabei habe ich groe Motivation, neue Sortimentsbereiche zu erlernen und mich voll und ganz neuen Aufgaben zu widmen.

Zuletzt war ich in einem innovativen Unternehmen der Haushaltswarenbranche beschftigt. Zu den Ttigkeiten in meiner beruflichen Laufbahn gehrten unter anderem:
- telefonische Kundenbetreuung und Produktberatung
- Auftragsbearbeitung von der Auftragsbesttigung bis zur Rechnung
- Angebotserstellung und Tagespreiskalkulation
- Untersttzung des Auendienstes
- Reklamationsmanagement
- Rckstands- und Terminverwaltung
- Stammdatenpflege
- Aufbereiten von Unternehmenskennzahlen
- Vor- und Nachbereitung von Messeauftritten sowie Messeteilnahme

Durch meine aktive und serviceorientierte Kundenbetreuung entwickelten sich neben meiner Fhigkeit zum selbststndigen und eigenverantwortlichen Arbeiten auch soziale Kompetenz und kommunikative Strke. Darber hinaus ist das zielorientierte Zusammen-arbeiten im Team fr mich von groer Bedeutung.

Ich kann Ihnen kurzfristig zur Verfgung stehen und freue mich auf eine Einladung zu einem persnlichen Vorstellungsgesprch.

Mit freundlichen Gren

